diff --git a/arch/arm/dts/am335x-brppt1-mmc-u-boot.dtsi b/arch/arm/dts/am335x-brppt1-mmc-u-boot.dtsi
index 0b9a1ccef4..a3d5650e48 100644
--- a/arch/arm/dts/am335x-brppt1-mmc-u-boot.dtsi
+++ b/arch/arm/dts/am335x-brppt1-mmc-u-boot.dtsi
@@ -78,3 +78,35 @@
 &scm_clocks {
 	compatible = "simple-bus";
 };
+
+&i2c0 {
+	u-boot,dm-pre-reloc;
+};
+
+&uart0 {
+	u-boot,dm-pre-reloc;
+};
+
+&mmc1 {
+	u-boot,dm-pre-reloc;
+};
+
+&mmc2 {
+	u-boot,dm-pre-reloc;
+};
+
+&gpio0 {
+	u-boot,dm-pre-reloc;
+};
+
+&gpio1 {
+	u-boot,dm-pre-reloc;
+};
+
+&gpio2 {
+	u-boot,dm-pre-reloc;
+};
+
+&gpio3 {
+	u-boot,dm-pre-reloc;
+};
diff --git a/arch/arm/dts/am335x-brppt1-mmc.dts b/arch/arm/dts/am335x-brppt1-mmc.dts
index bd2f6c2e3e..4db279b65e 100644
--- a/arch/arm/dts/am335x-brppt1-mmc.dts
+++ b/arch/arm/dts/am335x-brppt1-mmc.dts
@@ -12,25 +12,10 @@
 	model = "BRPPT1 (MMC) Panel";
 	compatible = "ti,am33xx";
 
-	fset: factory-settings {
-		bl-version	= "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456890";
-		version		= <0x0100>;
-		order-no	= "6PPT30 (MMC)";
-		hw-revision	= "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456890";
-		serial-no	= "0";
-		device-id	= <0x0>;
-		parent-id	= <0x0>;
-		hw-variant	= <0x1>;
-	};
 
 	aliases {
-		ds1bkl0 = &pwmbacklight;
-		ds1bkl1 = &tps_bl;
-		ds1timing = &timing0;
-		ds1ctrl = &lcdc;
 		gpmc = &gpmc;
 		mmc = &mmc2;
-		fset = &fset;
 	};
 
 	chosen {
@@ -43,110 +28,21 @@
 		reg = <0x80000000 0x10000000>; /* 256 MB */
 	};
 
-	panel {
-		status = "disabled";
-
-		compatible = "ti,tilcdc,panel";
-		enable-gpios = <&gpio0 6 GPIO_ACTIVE_LOW>;
-
-		backlight = <&pwmbacklight>;
-		bkl-pwm = <&pwmbacklight>;
-		bkl-tps = <&tps_bl>;
-
-		panel-info {
-			ac-bias		= <255>;
-			ac-bias-intrpt	= <0>;
-			dma-burst-sz	= <16>;
-			bpp		= <32>;
-			fdd		= <0x80>;
-			sync-edge	= <0>;
-			sync-ctrl	= <1>;
-			raster-order	= <0>;
-			fifo-th		= <0>;
-		};
-
-		display-timings {
-			native-mode = <&timing0>;
-			timing0: lcd {
-				clock-frequency	= <32000000>;
-				hactive		= <800>;
-				vactive		= <480>;
-				hfront-porch	= <2>;
-				hback-porch	= <192>;
-				hsync-len	= <1>;
-				vfront-porch	= <20>;
-				vback-porch	= <2>;
-				vsync-len	= <1>;
-				hsync-active	= <1>;
-				vsync-active	= <1>;
-				pupdelay	= <10>;
-				pondelay	= <10>;
-			};
-		};
-	};
-
 	vmmcsd_fixed: fixedregulator@0 {
 		compatible = "regulator-fixed";
 		regulator-name = "vmmcsd_fixed";
 		regulator-min-microvolt = <3300000>;
 		regulator-max-microvolt = <3300000>;
 	};
-
-	pwm0: omap-pwm@timer5 {
-		compatible = "ti,omap-dmtimer-pwm";
-		ti,timers = <&timer5>;
-		#pwm-cells = <3>;
-	};
-
-	pwm1: omap-pwm@timer6 {
-		compatible = "ti,omap-dmtimer-pwm";
-		ti,timers = <&timer6>;
-		#pwm-cells = <3>;
-	};
-
-	beeper: pwm-beep {
-		compatible = "pwm-beeper";
-		pwms = <&pwm0 0 0 0>;
-	};
-
-	pwmbacklight: pwm-bkl {
-		compatible = "pwm-backlight";
-		pwms = <&pwm1 0 5000000 0>;
-
-		default-brightness-level = <255>;
-		brightness-levels = <0 16 32 64 128 170 202 234 255>;
-
-		power-supply = <&vmmcsd_fixed>;
-		enable-gpios = <&gpio0 7 GPIO_ACTIVE_HIGH>;
-	};
 };
 
 &uart0 {		/* console uart */
-	u-boot,dm-spl;
-	status = "okay";
-};
-
-&uart1 {
 	status = "okay";
 };
 
 &i2c0 {
-	u-boot,dm-spl;
 	status = "okay";
 	clock-frequency = <400000>;
-
-	tps: tps@24 {		/* PMIC controller */
-		u-boot,dm-spl;
-		reg = <0x24>;
-		compatible = "ti,tps65217";
-
-		tps_bl: backlight {
-			compatible = "ti,tps65217-bl";
-			isel = <1>;	/* 1 - ISET1, 2 ISET2 */
-			fdim = <1000>;	/* TPS65217_BL_FDIM_1kHZ */
-			default-brightness = <50>;
-		};
-	};
 };
 
 &i2c2 {
@@ -158,10 +54,6 @@
 	status = "okay";
 };
 
-&cppi41dma  {
-	status = "okay";
-};
-
 &usb {
 	status = "okay";
 };
@@ -217,7 +109,6 @@
 };
 
 &mmc1 {
-	u-boot,dm-spl;
 	vmmc-supply = <&vmmcsd_fixed>;
 	bus-width = <0x4>;
 	ti,non-removable;
@@ -227,7 +118,6 @@
 };
 
 &mmc2 {
-	u-boot,dm-spl;
 	vmmc-supply = <&vmmcsd_fixed>;
 	bus-width = <0x8>;
 	ti,non-removable;
@@ -236,77 +126,20 @@
 	status = "okay";
 };
 
-&l4_per {
-
-	segment@300000 {
-
-		target-module@e000 {
-			u-boot,dm-pre-reloc;
-
-			lcdc: lcdc@0 {
-				u-boot,dm-pre-reloc;
-				status = "disabled";
-			};
-		};
-	};
-};
-
-&elm {
-	status = "okay";
-};
-
-&sham {
-	status = "okay";
-};
-
-&aes {
-	status = "okay";
-};
-
 &gpio0 {
-	u-boot,dm-spl;
 	ti,no-reset-on-init;
 };
 
 &gpio1 {
-	u-boot,dm-spl;
 	ti,no-reset-on-init;
 };
 
 &gpio2 {
-	u-boot,dm-spl;
 	ti,no-reset-on-init;
 };
 
 &gpio3 {
-	u-boot,dm-spl;
-	ti,no-reset-on-init;
-};
-
-&wdt2 {
 	ti,no-reset-on-init;
-	ti,no-idle-on-init;
-};
-
-&tscadc {
-	status = "okay";
-	tsc {
-		ti,wires = <4>;
-		ti,x-plate-resistance = <200>;
-		ti,zx-cutoff-ratio = <40>;
-		ti,min_deviation = <60>;
-		ti,max_deviation = <600>;
-		ti,coordinate-readouts = <5>;
-		ti,wire-config = <0x00 0x11 0x22 0x33>;
-
-		bnr-buttons {
-			Home-Button {};
-		};
-	};
-
-	adc {
-		ti,adc-channels = <5 6 7>;
-	};
 };
 
 &timer6 {		/* used for cpsw end device */
@@ -320,37 +153,3 @@
 	ti,no-reset-on-init;
 	ti,no-idle-on-init;
 };
-
-&wdt2 {
-	status = "okay";
-	ti,no-reset-on-init;
-	ti,no-idle-on-init;
-};
-
-&epwmss0 {
-	status = "okay";
-};
-
-&tscadc {
-	status = "okay";
-};
-
-&dcan0 {
-	status = "okay";
-};
-
-&dcan1 {
-	status = "okay";
-};
-
-&sham {
-	status = "disabled";
-};
-
-&aes {
-	status = "disabled";
-};
-
-&rng {
-	status = "disabled";
-};